
#include <stdio.h> 
#include <unistd.h> 
#include "common_defines.h"
#include "output.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
  
#define BUF_MAX 1024 
unsigned long long int sum(unsigned long long int *);
int read_fields (FILE *, unsigned long long int *); 
  
//int read_fields (FILE *fp, unsigned long long int *fields)
//{
//  int retval;
//  char buffer[BUF_MAX];
//
//
//  if (!fgets (buffer, BUF_MAX, fp))
//  { perror ("Error"); }
//  retval = sscanf (buffer, "cpu %Lu %Lu %Lu %Lu %Lu %Lu %Lu %Lu %Lu %Lu",
//                            &fields[0],
//                            &fields[1],
//                            &fields[2],
//                            &fields[3],
//                            &fields[4],
//                            &fields[5],
//                            &fields[6],
//                            &fields[7],
//                            &fields[8],
//                            &fields[9]);
//
//	printf("1th  field of the= %Lu\n",fields[1]);
//printf("2th  field of the= %Lu\n",fields[2]);
//printf("3th  field of the= %Lu\n",fields[3]);
//printf("4th  field of the= %Lu\n",fields[4]);
//  if (retval < 4) /* Atleast 4 fields is to be read */
//  {
//    fprintf (stderr, "Error reading /proc/stat cpu field\n");
//    return 0;
//  }
//  return 1;
//}
  
int ReadCpuUtilization (void)
{
  FILE *fp;
  unsigned long long int fields[10],fields_cpu1[10],fields_cpu2[10];
  unsigned long long int total_tick[3],total_tick_old[3],idle[3], idle_old[3],del_total_tick[3],del_idle[3];
  int update_cycle = 0, i, flag = 1,cpu=0;
  double percent_usage[3];

  fp = fopen ("/proc/stat", "r");
  if (fp == NULL)
  {
    perror ("Error");
  }


  if (!read_fields (fp, fields))
  { return 0; }

    if(!read_fields(fp,fields_cpu1))
    {return 0;}
    if(!read_fields(fp,fields_cpu2))
    {return 0;}

  total_tick[0]=sum(fields);
  total_tick[1]=sum(fields_cpu1);
  total_tick[2]=sum(fields_cpu2);

  idle[0] = fields[3]; /* idle ticks index */
  idle[1] = fields_cpu1[3];
  idle[2] = fields_cpu2[3];

    sleep (1);
    total_tick_old[0] = total_tick[0];
    total_tick_old[1] = total_tick[1];
    total_tick_old[2] = total_tick[2];
    idle_old[0] = idle[0];
    idle_old[1] = idle[1];
    idle_old[2] = idle[2];

    fseek (fp, 0, SEEK_SET);
    fflush (fp);

	if (!read_fields(fp, fields))
  	{ return 0; }
    if(!read_fields(fp,fields_cpu1))
    {return 0;}
    if(!read_fields(fp,fields_cpu2))
    {return 0;}

  total_tick[0]=sum(fields);
  total_tick[1]=sum(fields_cpu1);
  total_tick[2]=sum(fields_cpu2);


  idle[0] = fields[3]; /* idle ticks index */
  idle[1] = fields_cpu1[3];
  idle[2] = fields_cpu2[3];

    del_total_tick[0] = total_tick[0] - total_tick_old[0];
    del_total_tick[1] = total_tick[1] - total_tick_old[1];
    del_total_tick[2] = total_tick[2] - total_tick_old[2];

    del_idle[0] = idle[0] - idle_old[0];
    del_idle[1] = idle[1] - idle_old[1];
    del_idle[2] = idle[2] - idle_old[2];


    percent_usage[0] = ((del_total_tick[0] - del_idle[0]) / (double) del_total_tick[0]) * 100; /* 3 is index of idle time */
    //printf ("Total CPU Usage: %3.2lf%%\n", percent_usage[0]);
    percent_usage[1] = ((del_total_tick[1] - del_idle[1]) / (double) del_total_tick[1]) * 100; /* 3 is index of idle time */
    //printf (" \tCPU0 Usage: %3.2lf%%\n", percent_usage[1]);
    pd_response.cpu0_util = percent_usage[1];
    percent_usage[2] = ((del_total_tick[2] - del_idle[2]) / (double) del_total_tick[2]) * 100; /* 3 is index of idle time */
    pd_response.cpu1_util = percent_usage[2];
    //printf (" \tCPU1 Usage: %3.2lf%%\n", percent_usage[2]);
    update_cycle++;

    fclose (fp); /* Ctrl + C quit, therefore this will not be reached. We rely on the kernel to close this file */

  return 0;
}
unsigned long long int sum(unsigned long long int *temp_fields)
{
 int i;
unsigned long long int temp_total_tick;
  for (i=0, temp_total_tick = 0; i<10; i++)
  { temp_total_tick += temp_fields[i]; }
return temp_total_tick;
}

char StringCpuUtil[10];
//int ReadCpuUtilization(void)
//{
//	  FILE *fp;
//
//	  unsigned int len =10;
//	  unsigned int ptrread;
//	  system("/mnt/CpuUtilization.sh");
//	  int i = 0;
//
//	  fp = fopen ("/tmp/tmp_cpu_util", "r");
//	  if (fp == NULL)
//	  {
//		  error_print("Error opening /tmp/tmp_cpu_util");
//	    return 0;
//	  }
//	  //while ((ptrread = getline(&StringCpuUtil, &len, fp)) != -1)
//	  while( fgets (StringCpuUtil, len, fp)!= NULL )
//	  {
//		  //printf("Retrieved line of length %s :\n", StringCpuUtil);
//		  StringCpuUtil[strlen(StringCpuUtil) -2 ] = '\0';
//		 if(i==1)
//		 {
//			 pd_response.cpu0_util = atoi(StringCpuUtil);
//			 printf("CPU 0 util %d\n", pd_response.cpu0_util);
//			 //sprintf(StringCpuUtil, "%.2f", pd_response.cpu0_util);
//		 }
//		 if(i==2)
//		 {
//			 pd_response.cpu1_util = atoi(StringCpuUtil);
//			 printf("CPU 1 util %d\n", pd_response.cpu1_util);
//			 //sprintf(StringCpuUtil, "%.2f", pd_response.cpu1_util);
//		 }
//		 i++;
//	  }
//	  //printf("Retrieved line of length %f, %f :\n", pd_response.cpu0_util, pd_response.cpu1_util);
//      fclose (fp);
//
//      //i have to also read ddr frequency and cpu utilization.
//
//      pd_response.ddr_freq = 667;
//      return 0;
//}

//#define GET_CPU0_UTIL "echo 1 | top -b -d1 -n1|grep -i CPU0: awk '{print $2}'"
//#define GET_CPU1_UTIL "echo 1 | top -b -d1 -n1|grep -i CPU1: awk '{print $2}'"

#define GET_CPU0_UTIL "echo 1 | top -bn2 | sed -n '2p' | awk '{print $2}'"
#define GET_CPU1_UTIL "echo 1 | top -bn2 | sed -n '3p' | awk '{print $2}'"

char* GetCPUUtil(const char* command);

//void ReadCpuUtilization (void)
//{
//	char *read_string;
//
//	GetCPUUtil(GET_CPU0_UTIL);
//	StringCpuUtil[strlen(StringCpuUtil) -2 ] = '\0';
//	//error_print(StringCpuUtil);
//	pd_response.cpu0_util = atoi(StringCpuUtil);
//	printf("CPU 0: %0.2f\n", pd_response.cpu0_util);
//
//	GetCPUUtil(GET_CPU1_UTIL);
//	StringCpuUtil[strlen(StringCpuUtil) -2 ] = '\0';
//	//error_print(StringCpuUtil);
//	pd_response.cpu1_util = atoi(StringCpuUtil);
//	printf("CPU 1: %0.2f\n", pd_response.cpu1_util);
//
//	return 0;
//}


char* GetCPUUtil(const char* command) {
    FILE* fp;
    char* result = NULL;
    size_t len = 0;

    //fflush(NULL);
    fp = popen(command, "r");
    if (fp == NULL) {
        printf("Cannot execute command:\n%s\n", command);
        return;
    }

    while(getline(&result, &len, fp) != -1) {
        //fputs(result, stdout);
        strcpy(StringCpuUtil, result);
    }

    free(result);
    //fflush(fp);
    if (pclose(fp) != 0) {
        perror("Cannot close stream.\n");
    }
    return result;
}
